<?php

namespace App\DataTables;

use App\Models\Ordine;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class OrdineDataTableEditor extends DataTablesEditor
{
  protected $model = Ordine::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'riferimento.required' => 'Il riferimento è richiesto',
    'prenotazione_id.required' => 'La prenotazione è richiesta',
    'stato.required' => 'Il stato è richiesto',
    'prezzo.required' => 'Il prezzo è richiesto',
    'note.required' => 'La note è richiesta',
    'codice.required' => 'Il codice è richiesto',
    'stato_pagamento.required' => 'Il stato pagamento è richiesto',
    'metodo_pagamento.required' => 'Il metodo pagamento è richiesto',
    'info.required' => 'L\'info è richiesta',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'riferimento'  => 'required',
      'prenotazione_id' => 'required|exists:prenotazione,id',
      'stato' => 'required|string',
      'prezzo' => 'required|numeric',
      'note' => 'nullable',
      'codice' => 'required|unique:ordine,codice',
      'stato_pagamento' => 'nullable|string',
      'metodo_pagamento' => 'nullable|string',
      'info' => 'nullable|json',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'riferimento'  => 'required',
      'prenotazione_id' => 'required|exists:prenotazione,id',
      'stato' => 'required|string',
      'prezzo' => 'required|numeric',
      'note' => 'nullable',
      'codice' => 'required|unique:ordine,codice',
      'stato_pagamento' => 'nullable|string',
      'metodo_pagamento' => 'nullable|string',
      'info' => 'nullable|json',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
